/*****************************************************************/
/*      ____  ____  __    __    __  _______  ____  ___    ____   */
/*     / __ \/ __ \/ /   / /   /  |/  / __ \/ __ \/   |  / __ \  */
/*    / /_/ / / / / /   / /   / /|_/ / / / / /_/ / /| | / / / /  */
/*   / _, _/ /_/ / /___/ /___/ /  / / /_/ / _, _/ ___ |/ /_/ /   */
/*  /_/ |_|\____/_____/_____/_/  /_/\____/_/ |_/_/  |_/_____/    */
/*          ___ _   _ _  _   _   ___ ___   ___ __  _  __         */
/*         / __| | | | || | /_\ / __| __| |_  )  \/ |/  \        */
/*        | (_ | |_| | __ |/ _ \\__ \ _|   / / () | | () |       */
/*         \___|\___/|_||_/_/ \_\___/___| /___\__/|_|\__/        */
/*                                                               */
/*                    --- EIN TOLLES SPIEL ---                   */
/*                                                               */
/*         Jan Hapke, Wilhelm Mailnder, David Scherfgen         */
/*                                                               */
/*****************************************************************/

#ifndef BASICPARAMETER_H_INCLUDED
#define BASICPARAMETER_H_INCLUDED

#include "parameter.h"

// Template fr Parameter
template<typename T> class BasicParameter
	: public Parameter
{
public:
	BasicParameter(const T& value);

	BasicParameter* clone() const;

	const std::string toString() const;

	const T& getValue() const;

private:
	T value;
};

template<typename T> BasicParameter<T>::BasicParameter(const T& value)
	: value(value)
{

}

template<typename T> BasicParameter<T>* BasicParameter<T>::clone() const
{
	// Kopie erzeugen
	return new BasicParameter<T>(value);
}

template<typename T> const std::string BasicParameter<T>::toString() const
{
	std::ostringstream stream;
	stream << value;
	return stream.str();
}

template<typename T> const T& BasicParameter<T>::getValue() const
{
	return value;
}

#endif
