/*****************************************************************/
/*      ____  ____  __    __    __  _______  ____  ___    ____   */
/*     / __ \/ __ \/ /   / /   /  |/  / __ \/ __ \/   |  / __ \  */
/*    / /_/ / / / / /   / /   / /|_/ / / / / /_/ / /| | / / / /  */
/*   / _, _/ /_/ / /___/ /___/ /  / / /_/ / _, _/ ___ |/ /_/ /   */
/*  /_/ |_|\____/_____/_____/_/  /_/\____/_/ |_/_/  |_/_____/    */
/*          ___ _   _ _  _   _   ___ ___   ___ __  _  __         */
/*         / __| | | | || | /_\ / __| __| |_  )  \/ |/  \        */
/*        | (_ | |_| | __ |/ _ \\__ \ _|   / / () | | () |       */
/*         \___|\___/|_||_/_/ \_\___/___| /___\__/|_|\__/        */
/*                                                               */
/*                    --- EIN TOLLES SPIEL ---                   */
/*                                                               */
/*         Jan Hapke, Wilhelm Mailnder, David Scherfgen         */
/*                                                               */
/*****************************************************************/

#include "pch.h"
#include "blendtransition.h"

BlendTransition::BlendTransition(Application& app,
								 float duration)
	: Transition(app, false, duration)
{

}

void BlendTransition::render(GLuint oldImageTextureID,
							 GLuint newImageTextureID)
{
	// das alte Bild je nach Zeitpunkt unterschiedlich stark einblenden
	const float alpha = 1.0f - time / duration;
	glBindTexture(GL_TEXTURE_2D, oldImageTextureID);
	glBegin(GL_QUADS);
	glColor4f(1.0f, 1.0f, 1.0f, alpha);
	glTexCoord2i(0, 0);
	glVertex2f(-1.0f, 1.0f);
	glTexCoord2i(screenResolution.x, 0);
	glVertex2f(1.0f, 1.0f);
	glTexCoord2i(screenResolution.x, screenResolution.y);
	glVertex2f(1.0f, -1.0f);
	glTexCoord2i(0, screenResolution.y);
	glVertex2f(-1.0f, -1.0f);
	glEnd();
}
