/*****************************************************************/
/*      ____  ____  __    __    __  _______  ____  ___    ____   */
/*     / __ \/ __ \/ /   / /   /  |/  / __ \/ __ \/   |  / __ \  */
/*    / /_/ / / / / /   / /   / /|_/ / / / / /_/ / /| | / / / /  */
/*   / _, _/ /_/ / /___/ /___/ /  / / /_/ / _, _/ ___ |/ /_/ /   */
/*  /_/ |_|\____/_____/_____/_/  /_/\____/_/ |_/_/  |_/_____/    */
/*          ___ _   _ _  _   _   ___ ___   ___ __  _  __         */
/*         / __| | | | || | /_\ / __| __| |_  )  \/ |/  \        */
/*        | (_ | |_| | __ |/ _ \\__ \ _|   / / () | | () |       */
/*         \___|\___/|_||_/_/ \_\___/___| /___\__/|_|\__/        */
/*                                                               */
/*                    --- EIN TOLLES SPIEL ---                   */
/*                                                               */
/*         Jan Hapke, Wilhelm Mailnder, David Scherfgen         */
/*                                                               */
/*****************************************************************/

#ifndef CREDITSSTATE_H_INCLUDED
#define CREDITSSTATE_H_INCLUDED

#include "font.h"
#include "sound.h"
#include "state.h"
#include "texture.h"

// Zustand fr die Credits
class CreditsState
	: public State
{
public:
	CreditsState(Application& app);

	void onEnter(const ParameterMap& params);

	void onLeave();

	void onGotFocus();

	void onLostFocus();

	void update();

	void render();

private:
	FontHandle font;
	FontHandle bigFont;
	TextureHandle gradient;
	TextureHandle monster;
	SoundHandle scream;
	float xPos;
	float yPos;
	float speed;
	float height;
	bool shocked;
};

#endif
