/*****************************************************************/
/*      ____  ____  __    __    __  _______  ____  ___    ____   */
/*     / __ \/ __ \/ /   / /   /  |/  / __ \/ __ \/   |  / __ \  */
/*    / /_/ / / / / /   / /   / /|_/ / / / / /_/ / /| | / / / /  */
/*   / _, _/ /_/ / /___/ /___/ /  / / /_/ / _, _/ ___ |/ /_/ /   */
/*  /_/ |_|\____/_____/_____/_/  /_/\____/_/ |_/_/  |_/_____/    */
/*          ___ _   _ _  _   _   ___ ___   ___ __  _  __         */
/*         / __| | | | || | /_\ / __| __| |_  )  \/ |/  \        */
/*        | (_ | |_| | __ |/ _ \\__ \ _|   / / () | | () |       */
/*         \___|\___/|_||_/_/ \_\___/___| /___\__/|_|\__/        */
/*                                                               */
/*                    --- EIN TOLLES SPIEL ---                   */
/*                                                               */
/*         Jan Hapke, Wilhelm Mailnder, David Scherfgen         */
/*                                                               */
/*****************************************************************/

#include "pch.h"
#include "filelocator.h"

//wer htte das gedacht, hier kann man einen suchpfad registrieren
void FileLocator::addSearchPath(const std::string& path,
								int priority)
{
	//wenn bergebener pfad nicht mit verzeichnis-trenner('/') endet, diesen anhngen.
	std::string canonicalPath(path);
	if(canonicalPath[canonicalPath.length()-1] != '/') canonicalPath.push_back('/');

	//pfad dem vector hinzufgen
	searchPaths.push_back(SearchPathEntry(canonicalPath, priority));
	
	//vector sortieren (nach prioritt)
	std::sort(searchPaths.begin(), searchPaths.end());
}

void FileLocator::removeSearchPath(const std::string& path)
{
	// IMPLEMENTIER MICH!
	// LECK MICH!
	// (blde autoritre methodenrmpfe...)

	std::vector<SearchPathEntry>::iterator it;

	if(!findSearchPath(path, it))
		return;

	searchPaths.erase(it);
	return;
}

void FileLocator::changePathPriority(const std::string& path, int priority /* = 0 */)
{
	// bitte, bitte, lieber programmierer, wenn du gerade zeit hast, knntest du mir einen gefallen tun, und mich implementieren?
	// aber gerne doch.
	// (so lobe ich mir das. vorbildliches verhalten dieses methodenrumpfes. da implementiert man als programmierer doch gerne.)

	std::vector<SearchPathEntry>::iterator it;

	if(!findSearchPath(path, it))
		return;

	it->priority = priority;
	std::sort(searchPaths.begin(), searchPaths.end());

	return;
}
const std::string FileLocator::findFile(const std::string& filename) const
{
	//verzeichnisse zum durchsuchen sollten vorhanden sein...
	assert(!searchPaths.empty());

	//alle eintrge im vector durchgehen.
	for(std::vector<SearchPathEntry>::const_iterator it = searchPaths.begin();
		it != searchPaths.end(); 
		++it)
	{
		//versuchen, datei im verzeichnis zu ffen
		std::ifstream ifs((it->path + filename).c_str());
		if(!ifs.fail())
		{
			//wenn ffnen geklappt hat datei vorhanden, kompletten pfad + dateiname zurckgeben.
			return it->path + filename;
		}
	}

	//nix gefunden-> leeren string zurckgeben.
	return "";
}

bool FileLocator::findSearchPath(const std::string& path, std::vector<SearchPathEntry>::iterator &it)
{
	std::string tanga = path;

	if(tanga[tanga.length() - 1] != '/')
		tanga.push_back('/');

	for(it = searchPaths.begin();
		it != searchPaths.end();
		++it)
	{
		if(it->path == tanga)
			return true;
	}

	return false;
}
