/*****************************************************************/
/*      ____  ____  __    __    __  _______  ____  ___    ____   */
/*     / __ \/ __ \/ /   / /   /  |/  / __ \/ __ \/   |  / __ \  */
/*    / /_/ / / / / /   / /   / /|_/ / / / / /_/ / /| | / / / /  */
/*   / _, _/ /_/ / /___/ /___/ /  / / /_/ / _, _/ ___ |/ /_/ /   */
/*  /_/ |_|\____/_____/_____/_/  /_/\____/_/ |_/_/  |_/_____/    */
/*          ___ _   _ _  _   _   ___ ___   ___ __  _  __         */
/*         / __| | | | || | /_\ / __| __| |_  )  \/ |/  \        */
/*        | (_ | |_| | __ |/ _ \\__ \ _|   / / () | | () |       */
/*         \___|\___/|_||_/_/ \_\___/___| /___\__/|_|\__/        */
/*                                                               */
/*                    --- EIN TOLLES SPIEL ---                   */
/*                                                               */
/*         Jan Hapke, Wilhelm Mailnder, David Scherfgen         */
/*                                                               */
/*****************************************************************/

#ifndef GUHaselnutOBJECT_H_INCLUDED
#define GUHaselnutOBJECT_H_INCLUDED

#include "object.h"
#include "sound.h"
#include "texture.h"

class PlayerObject;

// Klasse fr die Guhaselnuss
class GuhaselnutObject
	: public Object
{
public:
	// Konstruktor: initialisiert das Objekt
	GuhaselnutObject(Layer& layer, const TiXmlElement* p_xml, const ParameterMap& gameParams);

	void update();

	void render();

	void onCollision(const Contact& contact);

	void onCapture(PlayerObject& player);

	PlayerObject& getCarrier() const;

private:
	TextureHandle sprites;
	SoundHandle takeSound;
	SoundHandle captureSound;
	SoundHandle spawnSound;
	float respawnTime;
	Vec2f spawnPosition;
	PlayerObject* p_carrier;
	float spawnCountDown;
};

#endif
