/*****************************************************************/
/*      ____  ____  __    __    __  _______  ____  ___    ____   */
/*     / __ \/ __ \/ /   / /   /  |/  / __ \/ __ \/   |  / __ \  */
/*    / /_/ / / / / /   / /   / /|_/ / / / / /_/ / /| | / / / /  */
/*   / _, _/ /_/ / /___/ /___/ /  / / /_/ / _, _/ ___ |/ /_/ /   */
/*  /_/ |_|\____/_____/_____/_/  /_/\____/_/ |_/_/  |_/_____/    */
/*          ___ _   _ _  _   _   ___ ___   ___ __  _  __         */
/*         / __| | | | || | /_\ / __| __| |_  )  \/ |/  \        */
/*        | (_ | |_| | __ |/ _ \\__ \ _|   / / () | | () |       */
/*         \___|\___/|_||_/_/ \_\___/___| /___\__/|_|\__/        */
/*                                                               */
/*                    --- EIN TOLLES SPIEL ---                   */
/*                                                               */
/*         Jan Hapke, Wilhelm Mail‰nder, David Scherfgen         */
/*                                                               */
/*****************************************************************/

#ifndef HIGHSCORESTATE_H_INCLUDED
#define HIGHSCORESTATE_H_INCLUDED

#include "font.h"
#include "state.h"
#include "highscoremanager.h"

// Highscore
class HighscoreState
	: public State
{
public:
	HighscoreState(Application& app);

	void onEnter(const ParameterMap& params);

	void onLeave();

	void onGotFocus();

	void onLostFocus();

	void update();

	void render();

private:
	FontHandle font;
	FontHandle bigFont;
	std::string levelFilename;
	ScoreType scoreType;
	unsigned int submittedScore;
	unsigned int submittedScore2;
	std::string input;
	std::string input2;
	std::string lastUsedName[2];
	int playerEntering;
	HighscoreManager manager;
	ScoreListType scores;
	const float cursorBlinkSpeed;
	const std::string::size_type maxNameLength;
};

#endif
