/*****************************************************************/
/*      ____  ____  __    __    __  _______  ____  ___    ____   */
/*     / __ \/ __ \/ /   / /   /  |/  / __ \/ __ \/   |  / __ \  */
/*    / /_/ / / / / /   / /   / /|_/ / / / / /_/ / /| | / / / /  */
/*   / _, _/ /_/ / /___/ /___/ /  / / /_/ / _, _/ ___ |/ /_/ /   */
/*  /_/ |_|\____/_____/_____/_/  /_/\____/_/ |_/_/  |_/_____/    */
/*          ___ _   _ _  _   _   ___ ___   ___ __  _  __         */
/*         / __| | | | || | /_\ / __| __| |_  )  \/ |/  \        */
/*        | (_ | |_| | __ |/ _ \\__ \ _|   / / () | | () |       */
/*         \___|\___/|_||_/_/ \_\___/___| /___\__/|_|\__/        */
/*                                                               */
/*                    --- EIN TOLLES SPIEL ---                   */
/*                                                               */
/*         Jan Hapke, Wilhelm Mailnder, David Scherfgen         */
/*                                                               */
/*****************************************************************/

#ifndef HOMEBASEOBJECT_H_INCLUDED
#define HOMEBASEOBJECT_H_INCLUDED

#include "object.h"
#include "texture.h"

class PlayerObject;

// "Homebase"-Objekt fr den "Capture the Guhaselnut"-Modus
class HomebaseObject
	: public Object
{
public:
	// Konstruktor: initialisiert das Objekt
	HomebaseObject(Layer& layer, const TiXmlElement* p_xml, const ParameterMap& gameParams);

	void update();

	void render();

	void onCollision(const Contact& contact);

private:
	TextureHandle sprites;
	int playerNo;
	Vec2f size;
	Vec2f originalPosition;
};

#endif
