/*****************************************************************/
/*      ____  ____  __    __    __  _______  ____  ___    ____   */
/*     / __ \/ __ \/ /   / /   /  |/  / __ \/ __ \/   |  / __ \  */
/*    / /_/ / / / / /   / /   / /|_/ / / / / /_/ / /| | / / / /  */
/*   / _, _/ /_/ / /___/ /___/ /  / / /_/ / _, _/ ___ |/ /_/ /   */
/*  /_/ |_|\____/_____/_____/_/  /_/\____/_/ |_/_/  |_/_____/    */
/*          ___ _   _ _  _   _   ___ ___   ___ __  _  __         */
/*         / __| | | | || | /_\ / __| __| |_  )  \/ |/  \        */
/*        | (_ | |_| | __ |/ _ \\__ \ _|   / / () | | () |       */
/*         \___|\___/|_||_/_/ \_\___/___| /___\__/|_|\__/        */
/*                                                               */
/*                    --- EIN TOLLES SPIEL ---                   */
/*                                                               */
/*         Jan Hapke, Wilhelm Mailnder, David Scherfgen         */
/*                                                               */
/*****************************************************************/

#ifndef IMAGELAYER_H_INCLUDED
#define IMAGELAYER_H_INCLUDED

#include "layer.h"
#include "texture.h"

// Layer, der nur ein Bild beinhaltet
class ImageLayer
	: public Layer
{
public:
	// Konstruktor: initialisiert den Layer
	ImageLayer(Level& level, int index, const TiXmlElement* p_xml, const ParameterMap& gameParams);

	void update();

	void render(Object* p_forceRenderingOnTop);

	void createShapes(b2Body& body);

private:
	TextureHandle image;	// das Bild des Layers
	Vec2f imageOffset;		// Offset des Bilds
	Vec2f tiling;			// Tiling des Bilds (wie oft der Inhalt wiederholt wird)
	Vec2f movement;			// Bewegung des Layers
	Vec2f position;			// aktuelle Position der Bewegung
};

#endif
