/*****************************************************************/
/*      ____  ____  __    __    __  _______  ____  ___    ____   */
/*     / __ \/ __ \/ /   / /   /  |/  / __ \/ __ \/   |  / __ \  */
/*    / /_/ / / / / /   / /   / /|_/ / / / / /_/ / /| | / / / /  */
/*   / _, _/ /_/ / /___/ /___/ /  / / /_/ / _, _/ ___ |/ /_/ /   */
/*  /_/ |_|\____/_____/_____/_/  /_/\____/_/ |_/_/  |_/_____/    */
/*          ___ _   _ _  _   _   ___ ___   ___ __  _  __         */
/*         / __| | | | || | /_\ / __| __| |_  )  \/ |/  \        */
/*        | (_ | |_| | __ |/ _ \\__ \ _|   / / () | | () |       */
/*         \___|\___/|_||_/_/ \_\___/___| /___\__/|_|\__/        */
/*                                                               */
/*                    --- EIN TOLLES SPIEL ---                   */
/*                                                               */
/*         Jan Hapke, Wilhelm Mailnder, David Scherfgen         */
/*                                                               */
/*****************************************************************/

#ifndef KINGAREAOBJECT_H_INCLUDED
#define KINGAREAOBJECT_H_INCLUDED

#include "object.h"
#include "texture.h"

class PlayerObject;

// "Knigsbereich"-Objekt fr den "King of the Hill"-Modus
class KingAreaObject
	: public Object
{
public:
	// Konstruktor: initialisiert das Objekt
	KingAreaObject(Layer& layer, const TiXmlElement* p_xml, const ParameterMap& gameParams);

	void update();

	void render();

	void onCollision(const Contact& contact);

private:
	typedef std::set<PlayerObject*> PlayerSetType;
	typedef std::map<PlayerObject*, float> PlayerTimeMapType;

	TextureHandle sprites;
	Vec2f size;
	PlayerSetType playersInside;
	PlayerTimeMapType playerTimes;
	RGBA color;
};

#endif
