/*****************************************************************/
/*      ____  ____  __    __    __  _______  ____  ___    ____   */
/*     / __ \/ __ \/ /   / /   /  |/  / __ \/ __ \/   |  / __ \  */
/*    / /_/ / / / / /   / /   / /|_/ / / / / /_/ / /| | / / / /  */
/*   / _, _/ /_/ / /___/ /___/ /  / / /_/ / _, _/ ___ |/ /_/ /   */
/*  /_/ |_|\____/_____/_____/_/  /_/\____/_/ |_/_/  |_/_____/    */
/*          ___ _   _ _  _   _   ___ ___   ___ __  _  __         */
/*         / __| | | | || | /_\ / __| __| |_  )  \/ |/  \        */
/*        | (_ | |_| | __ |/ _ \\__ \ _|   / / () | | () |       */
/*         \___|\___/|_||_/_/ \_\___/___| /___\__/|_|\__/        */
/*                                                               */
/*                    --- EIN TOLLES SPIEL ---                   */
/*                                                               */
/*         Jan Hapke, Wilhelm Mailnder, David Scherfgen         */
/*                                                               */
/*****************************************************************/

#ifndef MAINMENUSTATE_H_INCLUDED
#define MAINMENUSTATE_H_INCLUDED

#include "font.h"
#include "gamestate.h"
#include "playerobject.h"
#include "sound.h"
#include "state.h"
#include "texture.h"

enum MenuEntry {
	ME_LEVEL,
	ME_GAME_MODE,
	ME_POINTS,
	ME_CONTROL_MODE,
	ME_START_GAME,
	ME_HIGHSCORE,
	ME_CREDITS,
	ME_EXIT,

	ME_MAX_VALUE
};

// Zustand fr das Hauptmen
class MainMenuState
	: public State
{
public:
	MainMenuState(Application& app);

	void onEnter(const ParameterMap& params);

	void onLeave();

	void onGotFocus();

	void onLostFocus();

	void update();

	void render();

private:
	// ldt die Liste der Levels
	void loadLevelList();

	TextureHandle logo;
	FontHandle font;
	SoundHandle gh;
	SoundHandle ghear;
	SoundHandle gha;
	SoundHandle errorSound;
	SoundHandle neon;
	SoundInstanceHandle neonInst;
	MenuEntry selectedEntry;
	GameMode selectedMode;
	int selectedLevel;
	int numLevels;
	int pointsToWin;
	ControlMode controlModes[2];
	std::vector<std::string> levelFilenames;
	std::vector<std::string> levelNames;
	std::vector<std::string> levelGameModes;
	std::string input;
	std::string gameMode;
	std::string gameModeID;
	float logoBrightness;
	float menuEntryOffset[ME_MAX_VALUE];
};

#endif
