/*****************************************************************/
/*      ____  ____  __    __    __  _______  ____  ___    ____   */
/*     / __ \/ __ \/ /   / /   /  |/  / __ \/ __ \/   |  / __ \  */
/*    / /_/ / / / / /   / /   / /|_/ / / / / /_/ / /| | / / / /  */
/*   / _, _/ /_/ / /___/ /___/ /  / / /_/ / _, _/ ___ |/ /_/ /   */
/*  /_/ |_|\____/_____/_____/_/  /_/\____/_/ |_/_/  |_/_____/    */
/*          ___ _   _ _  _   _   ___ ___   ___ __  _  __         */
/*         / __| | | | || | /_\ / __| __| |_  )  \/ |/  \        */
/*        | (_ | |_| | __ |/ _ \\__ \ _|   / / () | | () |       */
/*         \___|\___/|_||_/_/ \_\___/___| /___\__/|_|\__/        */
/*                                                               */
/*                    --- EIN TOLLES SPIEL ---                   */
/*                                                               */
/*         Jan Hapke, Wilhelm Mailnder, David Scherfgen         */
/*                                                               */
/*****************************************************************/

#ifndef PCH_H_INCLUDED
#define PCH_H_INCLUDED

// Standard-Header
#include <algorithm>
#include <cassert>
#include <cmath>
#include <fstream>
#include <iostream>
#include <list>
#include <map>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <stdexcept>
#include <string>
#include <utility>
#include <vector>

// SDL und OpenGL
#include <SDL.h>
#include <SDL_opengl.h>
#include <SDL_image.h>

// OpenAL
#ifdef __MACOSX__
#include <al.h>
#include <alc.h>
#else
#include <AL/al.h>
#include <AL/alc.h>
#endif

// Box2D
#include <Box2D.h>

// Ogg, Vorbis
#include <ogg/ogg.h>
#include <vorbis/vorbisfile.h>

// TinyXML
#include <tinyxml.h>

// wichtige eigene Header
#include "noncopyable.h"
#include "parametermap.h"
#include "referencecounted.h"
#include "mtrand.h"
#include "utils.h"
#include "rgba.h"
#include "vec2.h"

// automatisch generierte Operatoren nutzen
using namespace std::rel_ops;

#endif
