/*****************************************************************/
/*      ____  ____  __    __    __  _______  ____  ___    ____   */
/*     / __ \/ __ \/ /   / /   /  |/  / __ \/ __ \/   |  / __ \  */
/*    / /_/ / / / / /   / /   / /|_/ / / / / /_/ / /| | / / / /  */
/*   / _, _/ /_/ / /___/ /___/ /  / / /_/ / _, _/ ___ |/ /_/ /   */
/*  /_/ |_|\____/_____/_____/_/  /_/\____/_/ |_/_/  |_/_____/    */
/*          ___ _   _ _  _   _   ___ ___   ___ __  _  __         */
/*         / __| | | | || | /_\ / __| __| |_  )  \/ |/  \        */
/*        | (_ | |_| | __ |/ _ \\__ \ _|   / / () | | () |       */
/*         \___|\___/|_||_/_/ \_\___/___| /___\__/|_|\__/        */
/*                                                               */
/*                    --- EIN TOLLES SPIEL ---                   */
/*                                                               */
/*         Jan Hapke, Wilhelm Mailnder, David Scherfgen         */
/*                                                               */
/*****************************************************************/

#include "pch.h"
#include "resource.h"
#include "resourcemanager.h"

Resource::Resource(ResourceManager& manager,
				   const std::string& filename,
				   const ParameterMap& options)
	: manager(manager)
	, filename(filename)
	, options(options)
{

}

Resource::~Resource()
{
	// sich selbst aus dem Manager lschen
	manager.removeResource(this);
}

ResourceManager& Resource::getManager() const
{
	return manager;
}

const std::string& Resource::getFilename() const
{
	return filename;
}

const ParameterMap& Resource::getOptions() const
{
	return options;
}

const ParameterMap Resource::getDefaultOptions()
{
	return ParameterMap();
}
