/*****************************************************************/
/*      ____  ____  __    __    __  _______  ____  ___    ____   */
/*     / __ \/ __ \/ /   / /   /  |/  / __ \/ __ \/   |  / __ \  */
/*    / /_/ / / / / /   / /   / /|_/ / / / / /_/ / /| | / / / /  */
/*   / _, _/ /_/ / /___/ /___/ /  / / /_/ / _, _/ ___ |/ /_/ /   */
/*  /_/ |_|\____/_____/_____/_/  /_/\____/_/ |_/_/  |_/_____/    */
/*          ___ _   _ _  _   _   ___ ___   ___ __  _  __         */
/*         / __| | | | || | /_\ / __| __| |_  )  \/ |/  \        */
/*        | (_ | |_| | __ |/ _ \\__ \ _|   / / () | | () |       */
/*         \___|\___/|_||_/_/ \_\___/___| /___\__/|_|\__/        */
/*                                                               */
/*                    --- EIN TOLLES SPIEL ---                   */
/*                                                               */
/*         Jan Hapke, Wilhelm Mailnder, David Scherfgen         */
/*                                                               */
/*****************************************************************/

#ifndef RESOURCEMANAGER_H_INCLUDED
#define RESOURCEMANAGER_H_INCLUDED

#include "handle.h"

class Application;
class FileLocator;
class Resource;

// Basisklasse fr Ressourcenmanager
class ResourceManager
{
public:
	// Konstruktor
	ResourceManager(Application& app, FileLocator& fileLocator);

	// virtueller Destruktor
	virtual ~ResourceManager() { }

	// ldt eine Ressource, wenn sie nicht bereits geladen ist
	virtual Resource* getResource(const std::string& filename, const ParameterMap& options, bool unmanagedCopy) = 0;

	// entfernt eine Ressource
	virtual void removeResource(Resource* p_resource) = 0;

	// liefert das Anwendungsobjekt
	Application& getApplication() const;

protected:
	Application& app;
	FileLocator& fileLocator;
};

#endif
