/*****************************************************************/
/*      ____  ____  __    __    __  _______  ____  ___    ____   */
/*     / __ \/ __ \/ /   / /   /  |/  / __ \/ __ \/   |  / __ \  */
/*    / /_/ / / / / /   / /   / /|_/ / / / / /_/ / /| | / / / /  */
/*   / _, _/ /_/ / /___/ /___/ /  / / /_/ / _, _/ ___ |/ /_/ /   */
/*  /_/ |_|\____/_____/_____/_/  /_/\____/_/ |_/_/  |_/_____/    */
/*          ___ _   _ _  _   _   ___ ___   ___ __  _  __         */
/*         / __| | | | || | /_\ / __| __| |_  )  \/ |/  \        */
/*        | (_ | |_| | __ |/ _ \\__ \ _|   / / () | | () |       */
/*         \___|\___/|_||_/_/ \_\___/___| /___\__/|_|\__/        */
/*                                                               */
/*                    --- EIN TOLLES SPIEL ---                   */
/*                                                               */
/*         Jan Hapke, Wilhelm Mailnder, David Scherfgen         */
/*                                                               */
/*****************************************************************/

#ifndef TEXTURE_H_INCLUDED
#define TEXTURE_H_INCLUDED

#include "basicresourcemanager.h"
#include "resource.h"

class Texture;

// Ressourcenmanager fr Texturen
BEGIN_IMPLEMENT_BASIC_RESOURCE_MANAGER(TextureManager, Texture)
END_IMPLEMENT_BASIC_RESOURCE_MANAGER

// Handle fr Texturen
typedef Handle<Texture> TextureHandle;

class Texture
	: public Resource
{
public:
	// Konstruktor: ldt die Textur
	Texture(TextureManager& manager, const std::string& filename, const ParameterMap& options);

	// Destruktor: lscht die Textur
	~Texture();

	// aktiviert die Textur
	void bind() const;

	// liefert die OpenGL-Textur-ID dieser Textur
	GLuint getTextureID() const;

	// liefert die Gre der Textur (in Pixeln)
	const Vec2i& getSize() const;

	// liefert die Standardoptionen
	static const ParameterMap getDefaultOptions();

private:
	GLuint textureID;
	Vec2i size;
	float textureMatrix[16];
};

#endif
