/*****************************************************************/
/*      ____  ____  __    __    __  _______  ____  ___    ____   */
/*     / __ \/ __ \/ /   / /   /  |/  / __ \/ __ \/   |  / __ \  */
/*    / /_/ / / / / /   / /   / /|_/ / / / / /_/ / /| | / / / /  */
/*   / _, _/ /_/ / /___/ /___/ /  / / /_/ / _, _/ ___ |/ /_/ /   */
/*  /_/ |_|\____/_____/_____/_/  /_/\____/_/ |_/_/  |_/_____/    */
/*          ___ _   _ _  _   _   ___ ___   ___ __  _  __         */
/*         / __| | | | || | /_\ / __| __| |_  )  \/ |/  \        */
/*        | (_ | |_| | __ |/ _ \\__ \ _|   / / () | | () |       */
/*         \___|\___/|_||_/_/ \_\___/___| /___\__/|_|\__/        */
/*                                                               */
/*                    --- EIN TOLLES SPIEL ---                   */
/*                                                               */
/*         Jan Hapke, Wilhelm Mailnder, David Scherfgen         */
/*                                                               */
/*****************************************************************/

#ifndef TILESET_H_INCLUDED
#define TILESET_H_INCLUDED

#include "texture.h"

class Tile;

// Klasse fr Tile-Sets
class TileSet
{
public:
	// Konstruktor: initialisiert das Tile-Set
	TileSet(Application& app, const TiXmlElement* p_xml);

	// Destruktor: lscht das Tile-Set
	~TileSet();

	// liefert das Tile mit der gegebenen ID
	const Tile* getTileByID(int id) const;

	// zeichnet Tiles beginnend von (0, 0) an mit einer Gre von 1x1 pro Tile
	void drawTiles(const Uint32* p_tiles, const Vec2i& size, int pitch, const RGBA& color = RGBA::WHITE) const;

private:
	typedef std::map<int, Tile*> TileMapType;

	Application& app;		// das Anwendungsobjekt
	TextureHandle image;	// Bild, auf dem die Tiles liegen
	TileMapType tiles;		// Infos ber die verschiedenen Tiles
};

#endif
