/*****************************************************************/
/*      ____  ____  __    __    __  _______  ____  ___    ____   */
/*     / __ \/ __ \/ /   / /   /  |/  / __ \/ __ \/   |  / __ \  */
/*    / /_/ / / / / /   / /   / /|_/ / / / / /_/ / /| | / / / /  */
/*   / _, _/ /_/ / /___/ /___/ /  / / /_/ / _, _/ ___ |/ /_/ /   */
/*  /_/ |_|\____/_____/_____/_/  /_/\____/_/ |_/_/  |_/_____/    */
/*          ___ _   _ _  _   _   ___ ___   ___ __  _  __         */
/*         / __| | | | || | /_\ / __| __| |_  )  \/ |/  \        */
/*        | (_ | |_| | __ |/ _ \\__ \ _|   / / () | | () |       */
/*         \___|\___/|_||_/_/ \_\___/___| /___\__/|_|\__/        */
/*                                                               */
/*                    --- EIN TOLLES SPIEL ---                   */
/*                                                               */
/*         Jan Hapke, Wilhelm Mailnder, David Scherfgen         */
/*                                                               */
/*****************************************************************/

#ifndef TRANSITION_H_INCLUDED
#define TRANSITION_H_INCLUDED

class Application;

// Basisklasse fr bergangseffekte
class Transition
{
public:
	// Konstruktor
	Transition(Application& app, bool needsNewImageTexture, float duration = -1.0f);

	virtual ~Transition() { }

	// aktualisiert den Effekt und liefert false, wenn er beendet ist
	virtual bool update();

	// rendert den Effekt
	virtual void render(GLuint oldImageTextureID, GLuint newImageTextureID) = 0;

	// liefert true, wenn der Effekt zum Rendern auch das neue Bild als Textur braucht
	bool getNeedsNewImageTexture() const;

protected:
	Application& app;
	bool needsNewImageTexture;
	float duration;
	float time;
	const Vec2i screenResolution;
};

#endif
